{{
''***********************************************
''*  Program 12Opt.spin
''*  Author: Jon Titus 05-23-2014 Rev. 1
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Program used to test sign-extend code for a
''*  10-bit 2's-complement value.
''*  Uses P8X32A Propeller-I board.
''***********************************************
}}

CON

  _clkmode      = xtal1 + pll16x    'Set MCU clock operation
  _xinfreq      = 5_000_000         'Set for 5 MHz crystal

VAR
  ''Create variables for serial output for the
  ''Parallax Serial Terminal (PST) for 2's-complement test.

  byte PropPin_SerOut           'Variable for P8X32A pin P30
  byte PropPin_SerIn            'Variable for P8X32A pin P31
  byte PropPin_SerMode          'Variable for P8X32A serial comm format
  word SerPort_BaudRate         'Variable for P8X32A serial comm bit rate         
  long Long_Value
  word Test_Value                
  
OBJ

  pst   :  "FullDuplexSerial"   'Serial library for testing

PUB main

 PropPin_SerOut    := 30        'P30 for USB transmit connection with host PC
 PropPin_SerIn     := 31        'P31 for USB receive connection with host PC
 PropPin_SerMode   := 0         'Invert RX mode. See FullDuplexSerial.spin.
 SerPort_BaudRate  := 9600      'Set baud rate at 9600 per second
  
'Configure Propeller serial port to communicate with host PC via
'Parallax Serial Terminal (PST)
pst.Start(PropPin_SerIn, PropPin_SerOut, PropPin_SerMode, SerPort_BaudRate)

repeat   
  'Test_Value := %1001011111            '2's comp of -417
  Test_Value := %0010000110             '2's complement of 134             

  if (Test_Value >  511)
    Long_Value := $FFFFFC00 | Test_Value
  else
    Long_Value := Test_value            
        
  pst.dec(Long_Value)                 'Print 32-bit signed value
        
  pst.Tx(13)                          'Move cursor to start a new line
                                      'Run the repeat loop again and again...
'-----end of Program Opt.spin-----
      