{{
''***********************************************
''*  Program 15.1 4-Bit R-2R DAC Test
''*  Author: Jon Titus 08-22-2013 Rev. 1
''*  Copyright 2013
''*  Released under Apache 2 license
''*  Output a 4-bit value to a 4-bit R-2R resistor-  
''*  ladder DAC circuit and increment the count by  
''*  one each time space bar pressed on keyboard.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x       'Set MCU clock operation
    _xinfreq = 5_000_000            'Set for 5 MHz crystal
   
OBJ

  delay     :  "timing"             'timing.spin file
  pst       :  "FullDuplexSerial"   'Serial library for testing
  
VAR

  byte PropPin_SerOut           'Variable for P8X32A pin P30
  byte PropPin_SerIn            'Variable for P8X32A pin P31
  byte PropPin_SerMode          'Variable for P8X32A serial comm format
  word SerPort_BaudRate         'Variable for P8X32A serial comm bit rate
  byte DAC_value                'Variable for output to DAC circuit
  byte PST_value                'Variable for data received from PST
  
PUB main                                              
 
 PropPin_SerOut    := 30        'P30 for USB transmit connection with host PC
 PropPin_SerIn     := 31        'P31 for USB receive connection with host PC
 PropPin_SerMode   := 0         'Invert RX mode. See FullDuplexSerial.spin.
 SerPort_BaudRate  := 9600      'Set baud rate at 9600 per second

 DIRA[23..16] := $0F            'Set four LED pins as outputs
 DIRA[11..8] := %1111           'Set four outputs to drive DAC circuit

'Configure Propeller serial port to communicate with host PC via
'Parallax Serial Terminal (PST)
 pst.Start(PropPin_SerIn, PropPin_SerOut, PropPin_SerMode, SerPort_BaudRate)

 pst.RxFlush                    'Clear contents of serial-receiver buffer
 DAC_value := %0000             'Initialize DAC output to zero

 'Repeat loop for 'accept a "space" character and increment DAC_value'
 repeat                     
    
        PST_value := pst.rx             'Get value (if any) from serial input
         
        if PST_value == $20             'If received value = kbrd "space bar"
            DAC_value := 1 + DAC_value  'increment DAC_value by one
            pst.RxFlush                 'clear contents of serial buffer
            
    OUTA[23..16] := DAC_value           'Output DAC_value to LEDs
    OUTA[11..8] := DAC_value            'Output DAC_value to DAC circuit
 
'' -----End Program 15.1-----        
        
        
  