{{
''***********************************************
''*  Program 15.4 Test of LTC1450L 12-bit DAC
''*  Author: Jon Titus 08-27-2013 Rev. 2
''*  Copyright 2013
''*  Released under Apache 2 license
''*  Output a 12-bit value to LTC1450L DAC and  
''*  increment the count by one each
''*  pass through the repeat loop.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x   'Set MCU clock operation
    _xinfreq = 5_000_000        'Set for 5 MHz crystal

    Hi = 1                      'Setting for logic-1
    Lo = 0                      'Setting for logic-0
    
VAR
 word DAC_value                 'Variable for output to 12-bit DAC circuit

PUB main                                              
 
 DIRA[15..8]  := %11111111      'Set eight outputs to drive DAC circuit
 'P8  to D0 and D8 on DAC
 'P9  to D1 and D9
 'P10 to D2 and D10
 'P11 to D3 and D11
 'P12 to D4
 'P13 to D5
 'P14 to D6
 'P15 ro D7
 
 DIRA[27..24] := $F             'Set four control pins as outputs  
 OUTA[27..24] := %1111          'Clear four control lines, set to logic-1
 'P24 to /CSMSB
 'P25 to /WR
 'P26 to /CSLSB
 'P27 to /LDAC
 
 DAC_value  := 0                'Initialize DAC output to zero to start

 'Repeat this loop forever
 repeat                     
    DAC_value := 1 + DAC_value      'Increment DAC_value by one
        
    OUTA[11..8] := DAC_value >> 8   'Output 4 MSBs to DAC
    OUTA[24] := Lo                  '/CSMSB to logic-0
    OUTA[25] := Lo                  '/WR to logic-0
    OUTA[25] := Hi                  '/WR to logic-1
    OUTA[24] := Hi                  '/CSMSB to logic-1

    
    OUTA[15..8] := DAC_value        'Output 8 LSBs to DAC
    OUTA[26] := Lo                  '/CSLSB to logic-0
    OUTA[25] := Lo                  '/WR to logic-0
    OUTA[25] := Hi                  '/WR to logic-1
    OUTA[26] := Hi                  '/CSLSB to logic-1

    OUTA[27] := Lo                  'Pulse the /LDAC pin to logic-0
    OUTA[27] := Hi                  '/LDAC back to logic-1
    
'' -----End-----        
        
        
  