{{
''***********************************************
''*  Program 15.5 Test of LTC1450L 12-bit DAC
''*  Author: Jon Titus 08-27-2013 Rev. 1
''*  Copyright 2013
''*  Released under Apache 2 license
''*  Output values to LTC1450L DAC to create a triangle  
''*  waveform on the DAC output. Each "side"
''*  of the triangle wave has 64 DAC voltage steps.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x   'Set MCU clock operation
    _xinfreq = 5_000_000        'Set for 5 MHz crystal

    Hi = 1                      'Setting for logic-1
    Lo = 0                      'Setting for logic-0
    
VAR
 word DAC_value                 'Variable for output to 12-bit DAC circuit

PUB main                                              
 
 DIRA[15..8]  := %11111111      'Set eight outputs to drive DAC circuit
 'P8 to D0 and D8 on DAC
 'P9 to D1 and D9
 'P10 to D2 and D10
 'P11 to D3 and D11
 'P12 to D4
 'P13 to D5
 'P14 to D6
 'P15 ro D7
 
 DIRA[27..24] := $F             'Set four control pins as outputs  
 OUTA[27..24] := %1111          'Clear four control lines, set to logic-1
 'P24 to /CSMSB
 'P25 to /WR
 'P26 to /CSLSB
 'P27 to /LDAC
 
 DAC_value  := 0                'Initialize DAC output to zero to start

 'Repeat this loop forever
 repeat                     

    repeat 63                       'go through loop 63 times
        Output_DAC_data(DAC_value)  'output DAC_value to LTC1450L
        DAC_value += 64             'add 64 to DAC_value
     
    repeat 63                       'go through loop 63 times
        Output_DAC_data(DAC_value)  'output DAC_value to LTC1450L
        DAC_value -= 64             'subtract 64 from DAC_value
        
'Object to output a 12-bit value to the LTC1450L 12-bit DAC
PUB Output_DAC_data (DAC_out)
 
    OUTA[11..8] := DAC_out >> 8     'Output 4 MSBs to DAC
    OUTA[24] := Lo                  '/CSMSB to logic-0
    OUTA[25] := Lo                  '/WR to logic-0
    OUTA[25] := Hi                  '/WR to logic-1
    OUTA[24] := Hi                  '/CSMSB to logic-1

    OUTA[15..8] := DAC_out          'Output 8 LSBs to DAC
    OUTA[26] := Lo                  '/CSLSB to logic-0
    OUTA[25] := Lo                  '/WR to logic-0
    OUTA[25] := Hi                  '/WR to logic-1
    OUTA[26] := Hi                  '/CSLSB to logic-1

    OUTA[27] := Lo                  'Pulse the /LDAC pin to logic-0
    OUTA[27] := Hi                  '/LDAC back to logic-1   
    
'' -----End Program 15.5-----        
        
        
  