{{
''***********************************************
''*  Program 16.1 DAC Ramp Test
''*  Author: Jon Titus 10-17-2014 Rev. 2
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Uses Parallax P8X32A Propeller board.
''*  Use LTC1450L DAC IC as an 8-bit DAC to
''*  create a positive-going ramp as a test.
''*  8 bits connect to 8 MSBs. 4 LSBs connect
''*  ground (logic-0).
''***********************************************
}}

CON

  _clkmode      = xtal1 + pll16x    'Set MCU clock operation
  _xinfreq      = 5_000_000         'Set for 5 MHz crystal

VAR

byte Counter                        'Variable for loop counter and DAC output               

OBJ
  delay :   "timing"                'Use the objects in the timing.spin code
  
PUB main

 dira[15..8] := %11111111           'Set P15--P8 as output pins for 8-bit DAC (MSBs)
 outa[15..8] := %00000000           'Set pins P15--P8 as 0's to clear DAC

 dira[24] := %1                     'Set P24 as an output pin to latch DAC data
 outa[24] := %1                     'Set pin P24 as logic 1
 
'Code to initialize the DAC
 Counter     := 0                   'Set Counter to zero to start DAC at 0 volts
 outa[15..8] := Counter             'Reset DAC for 0 volts out
 outa[24]    := %0                  'Load DAC with data, set pin 24 as logic-0                
 outa[24]    := %1                  'Take pin 24 back to a logic-1 to latch data

repeat
    outa[15..8] := Counter          'Output Counter value on P15--P8
    outa[24]    := 0                'Load DAC with data, set pin 24 as logic 0                
    outa[24]    := 1                'Take pin 24 back to a logic 1
    Counter++                       'Add 1 to Counter value
    delay.pause1ms(100)             'Wait 0.1 second (100 msec.)

 'end of Program 16.1  
    
 