'' =================================================================================================
''
''   File....... jm_nec6121_rx_demo.spin
''   Purpose.... NEC6121 IR protocol receiver demo
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 27 FEB 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000


con

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control
  

con

  ' Roku video player remote codes

  ROKU_HOME  = $FF_00_EF_BE
  ROKU_UP    = $FE_01_EF_BE
  ROKU_LF    = $FD_02_EF_BE
  ROKU_SEL   = $FC_03_EF_BE  
  ROKU_RT    = $FB_04_EF_BE
  ROKU_DN    = $FA_05_EF_BE
  ROKU_RWD   = $F9_06_EF_BE
  ROKU_PAUSE = $F8_07_EF_BE
  ROKU_FF    = $F7_08_EF_BE

  
obj

  ir   : "jm_nec6121_rx"                                        ' nec decoding 
  term : "fullduplexserial"                                     ' for terminal output


pub main | code

  ir.init(7)                                                    ' IR demod on p7
  
  term.start(31, 30, %0000, 115_200)                            ' use programming port
  pause(1)

  term.tx(CLS)
  term.str(string("Roku Remote Sniffer", CR))
  term.str(string("(NEC6121 protocol)", CR, CR))    

  repeat
    code := ir.rx                                               ' wait for IR code
    case code
      ROKU_HOME  : term.str(string("Home........... "))
      ROKU_UP    : term.str(string("Up............. "))
      ROKU_LF    : term.str(string("Left........... "))
      ROKU_SEL   : term.str(string("Select......... "))
      ROKU_RT    : term.str(string("Right.......... "))
      ROKU_DN    : term.str(string("Down........... "))
      ROKU_RWD   : term.str(string("Rewind......... "))      
      ROKU_PAUSE : term.str(string("Pause/Resume... "))
      ROKU_FF    : term.str(string("Fast Forward... "))
      other      : term.str(string("?.............. "))
                   
    term.hex(code, 8)               
    term.tx(CR)
            
    pause(250)                                                  ' allow key release


pub pause(ms) | t

  t := cnt                                                      ' sync with system counter
  repeat ms
    waitcnt(t += MS_001)           

    