{{
''***********************************************
''*  Program version EX19.1.spin
''*  Author: Jon Titus 12-12-2013 Rev. 2
''*  Program transmits a byte via UART1. 555 timer modulates
''*  data and drives an infrared (IR) LED. Modulation at
''*  38 kHz. IR sensor Vishay, type TSOP38238. Program
''*  receives byte from IR sensor and
''*  displays byte as an ASCII character.
''*  Note "receiver-inversion bit" set for UART1 in
''*  the UART1.start command.
''*  Uses P8X32A Propeller-I board.
''*  Set PST to 9600 bits/sec.
''***********************************************
}}

'Set up clock frequency
CON _clkmode = xtal1 + pll16x               'Set MCU clock operation
    _xinfreq = 5_000_000                    'Set for 5 MHz crystal

VAR

    byte char_in                            'Storage for byte received from UART1
    
obj

  UART1 : "fullduplexserial"                'Object for IR LED and sensor I/O
  term  : "fullduplexserial"                'Object to control Parallax Serial Terminal
  delays : "timing"                         'Timing object                             
                                                       
pub main
  
  UART1.start(24, 25, %0001, 2400)          'Start LED UART with these settings
                                            'Note inversion bit set
  term.start(31, 30, %0000, 9600)           'Start PST with these settings 

 repeat                                     'Repeat this loop "forever"
    delays.pause1ms(8)                      'Wait 8 milliseconds
    UART1.tx(%01101010)                     'Transmit this byte to 555-timer IC                     
    char_in := UART1.rx                     'Receive this byte (inverted) from IR sensor
    term.tx(char_in)                        'Display received byte in PST window
    
 '---end of Program EX19.1-----