''*****************************************************
''*  Program 23.1, Direct drive of an N-channel MOSFET
''*  by an output pin on the Propeller P8X32A board.
''*  Jon Titus, 07-22-2014 Rev. 1
''*  Copyright 2014
''*  Software uses the I/O connection at P27 on the
''*  Propeler board.                               
''*****************************************************
OBJ    
    delay     : "timing"            'timing.spin file
  
CON

  _CLKMODE      = XTAL1 + PLL4X     'set MCU clock operations
  _XINFREQ      = 5_000_000         '5MHz Crystal

PUB Main

 'A simple output program that changes the state of the P27
 'I/O pin (set for output). A 10-second time delay lets you
 'see the action at the P27 pin and on the 10 LEDs controlled
 'by the MOSFET.
  

 DIRA[27] := %1                'Set P8X32A board LED pin as output
                                           
repeat                         'This main loop runs "forever"

  OUTA[27..24] := %1111        'Make I/O pin P27 logic-1
  delay.pause1ms(10000)        '10-sec delay
  OUTA[27..24] := %0000        'Make I/O pin P27 logic-0
  delay.pause1ms(10000)        '10-sec delay

  '-----end Program 23.1-----      