{{
''***********************************************
''*  Program 23.2
''*  Author: Jon Titus 07-22-2014 Rev. 1
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Ten LEDs dim or brighten depending on the
''*  value entered from the PC keyboard via the
''*  Parallax Serial Terminal. Rejects values
''*  outside the range 0 to 100 and prints
''*  an error message. The controlling circuit
''*  uses an IRL620 MOSFET with an added 330-ohm
''*  gate resistor. PWM output on pin P27
''*  Added statements set PWM period.
''*  pwm1.SetPeriod(1_600_000) = 2 msec.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal
    
    max_duty = 100                      'Maximum 100% duty cycle
    pwm1pin  = 27                       'Control LED at P22
    

VAR byte ser_data                       'Byte storage for PWM duty cycle

OBJ
  pwm1  :  "pwmasm"                     'Ensure you have pwmasm.spin file
                                        'in your working directory
  Serial : "Extended_FDSerial"          'Serial communication object file
                                        'also goes in working directory
                                          
PUB Start                               'Main program starts here
  pwm1.start(pwm1pin)                   'Startup for LED at P27
  pwm1.SetDuty(0)                       'Start duty cycle at 0 percent
  pwm1.SetPeriod(1_600_000)             'Set period for 20 msec.

  Serial.start(31,30,0,9600)            'Set serial communications, P31 RX
                                        'Pin 30 TX, 0 = reset options
                                        '9600 = baud rate. Must be same as
                                        'Parallax Serial Terminal (PST)
  Serial.RxFlush                        'Clean out receiver buffer                                      

  repeat                                'repeat this loop "forever"                                
    ser_data := Serial.RxDec            'Get received data, convert to decimal
                                        'Check for value 0 to 100
    if ((ser_data <0) OR (Ser_data >100))
        Serial.str(String("Only values between 0 and 100, please."))
        Serial.tx(13)
    else
        pwm1.SetDuty(ser_data)          'Set PWM duty cycles to decimal value
        
    waitcnt(1_000_000 + cnt)            'short delay between changes

    