{{
''***********************************************
''*  Program 6.1. Pulse-width modulation (PWM)
''*  Test Program.
''*  Author: Jon Titus 12-05-2014 Rev. 1
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Two LEDs alternate bright-dim-bright cycles
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal
    
    max_duty = 100                      'Maximum 100% duty cycle
    pwm1pin  = 22                       'Control LED at P22
    pwm2pin  = 23                       'Control LED at P2  

OBJ
  pwm1  :  "pwmasm"                     'Ensure you have pwmasm.spin file
  pwm2  :  "pwmasm"                     'in your working directory

PUB go | x                              'declare x as a local variable
  pwm1.start(pwm1pin)                   'Startup for LED at P22
  pwm2.start(pwm2pin)                   'Startup for LED at P23
   
  repeat                                'Advance duty cycle from 0 to 100

    repeat x from 0 to max_duty
      pwm1.SetDuty(x)                   'LED P22 brightens
      pwm2.SetDuty(100-x)               'LED P23 dims
      waitcnt(1_000_000 + cnt)          'short delay between changes

    repeat x from max_duty to 0
      pwm1.SetDuty(x)                   'LED P22 dims
      pwm2.SetDuty(100-x)               'LED P23 brightens
      waitcnt(1_000_000 + cnt)          'short delay between changes