{{
''***********************************************
''*  Program 6.2
''*  Author: Jon Titus 12-05-2014 Rev. 1
''*  Copyright 2043
''*  Released under Apache 2 license
''*  Two LEDs dim or brighten depending on the
''*  value entered from the PC keyboard via the
''*  Parallax Serial Terminal. Acceptable values
''*  range from 0 (off) to 100 (full on)
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal
    
    max_duty = 100                      'Maximum 100% duty cycle
    pwm1pin  = 22                       'Control LED at P22
    pwm2pin  = 23                       'Control LED at P23

VAR byte ser_data                       'Byte storage for PWM duty cycle

OBJ
  pwm1  :  "pwmasm"                     'Ensure you have pwmasm.spin file
  pwm2  :  "pwmasm"                     'in your working directory
  Serial : "Extended_FDSerial"          'Serial communication object file
                                        'also goes in working directory
                                          
PUB Start                               'Main program starts here
  pwm1.start(pwm1pin)                   'Startup for LED at P22
  pwm2.start(pwm2pin)                   'Startup for LED at P23 
  pwm1.SetDuty(0)                       'Start with both LEDs off
  pwm2.SetDuty(0)

  Serial.start(31,30,0,9600)            'Set serial communications, P31 RX
                                        'Pin 30 TX, 0 = reset options
                                        '9600 = baud rate. Must be same as
                                        'Parallax Serial Terminal (PST)
  Serial.RxFlush                        'Clean out receiver buffer                                      

  repeat                                'repeat loop "forever"                                
    ser_data := Serial.RxDec            'Get received value, convert to decimal
    pwm1.SetDuty(ser_data)              'Set PWM duty cycles to decimal value
    pwm2.SetDuty(ser_data)              'for both PWM outputs
    waitcnt(1_000_000 + cnt)            'short delay between changes

    