{{
''***********************************************
''*  Program 7.3
''*  Author: Jon Titus 11-03-2014 Rev. 1
''*  Copyright 2013
''*  Released under Apache 2 license
''*  Display counter demonstration that
''*  goes through count 00 to 99 on two
''*  7-segment displays. A logic-1 output on
''*  P26 or P27 turns on respective display.
''*  LDS-C512RI display with 39-ohm resistors
''*  ULN2003A driver for common cathodes
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal
    
VAR
    byte segment_code[10]               'Storage for segment codes
    byte count
    byte tens
    byte units
    byte display_loop
    byte digit[2]                          'Variable for loop 
                                          
PUB Start                               'Main program starts here

segment_code[0] := %01111110            'Pattern for "0"
segment_code[1] := %00110000            'Pattern for "1"
segment_code[2] := %01101101            'Pattern for "2"
segment_code[3] := %01111001            'Pattern for "3"
segment_code[4] := %00110011            'Pattern for "4"
segment_code[5] := %01011011            'Pattern for "5"
segment_code[6] := %00011111            'Pattern for "6"
segment_code[7] := %01110000            'Pattern for "7"
segment_code[8] := %01111111            'Pattern for "8"
segment_code[9] := %01110011            'Pattern for "9"

digit[0] := 0                           'Storage for left-most digit
digit[1] := 0                           'Storage for digit to the right

dira[15..8] := %11111111                'Set eight output pins for display
dira[27..26] :=%11                      'Set display-switch outputs
outa[26] := 0                           'Clear display-switch outputs
outa[27] := 0
  repeat                                'Main loop
        repeat tens from 0 to 9         'Loop for 10's digit
            digit[0] := tens
            repeat units from 0 to 9    'Loop for units digit
                digit[1] := units
                repeat display_loop from 0 to 59
                    repeat count from 0 to 1
                        outa[26+count] := 0
                        outa[15..8] := segment_code[digit[count]]
                        outa[26+count] :=1
                        waitcnt(clkfreq/120 + cnt)
                        outa[26+count] := 0
                

 