{{
''***********************************************
''*  Program 7.5
''*  Author: Jon Titus 11-03-2014 Rev. 1
''*  Copyright 2013
''*  Released under Apache 2 license
''*  Display counter demonstration that
''*  separates a 4-digit value into seaparte
''*  numerals and displays four digits on a
''*  LUMEX LDQ-N516RI 4-digit display module.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal
    
VAR
    byte segment_code[10]               'Storage for segment codes
    byte count                          'Counter used in display loop
    byte display_loop                   'Counter used for display-loop delay
    byte digit[6]                       'Space for 6 digits
    long big_value                      'Variable for large value to parse 
    byte numb_of_digits                 'Number of digits in big_value
    long divisor                        'Divisor used to start parsing
    byte index                          'Index to identify each digit
    byte decimal_counter                'Counter to track each decimal digit
                                          
PUB Start                               'Main program starts here

segment_code[0] := %01111110            'Pattern for "0"
segment_code[1] := %00110000            'Pattern for "1"
segment_code[2] := %01101101            'Pattern for "2"
segment_code[3] := %01111001            'Pattern for "3"
segment_code[4] := %00110011            'Pattern for "4"
segment_code[5] := %01011011            'Pattern for "5"
segment_code[6] := %00011111            'Pattern for "6"
segment_code[7] := %01110000            'Pattern for "7"
segment_code[8] := %01111111            'Pattern for "8"
segment_code[9] := %01110011            'Pattern for "9"

digit[0] := 0                           'Storage for left-most digit
digit[1] := 0                           'Storage for digit to the right

dira[15..8] := %11111111                'Set eight output pins for display
dira[27..24] :=%1111                    'Set display-switch outputs
outa[27..24] := %0000                   'Clear display-switch outputs
                                        '  for control of 4 7-segment displays
big_value := 7286                       'Large value to work with
numb_of_digits := 4                     'Number of digits in big_value
divisor := 1                            'Starting value of divisor

'LOOP 1: Given the number of digits, calculate the largest divisor.
'  For four digits, start with 1000, for example.

  repeat decimal_counter from 1 to (numb_of_digits - 1)                                
    divisor := divisor * 10
        
 
'LOOP 2: Use divisor to separate the numerals. Use (numb_of_digits - 1)
'  so loop can go from digit[0] to digit[3] for a 4-digit
'  value, which saves four values.
 
  repeat index from 0 to (numb_of_digits - 1)
    digit[index] := big_value / divisor
    big_value := big_value - (digit[index] * divisor)
    divisor := divisor / 10
    
 'LOOP 3: OK, big-value separated, display the first 2 digits
 '  "forever." To display the last 2 individual digits,
 '  add two to the count in:
 '  outa[15..8] := segment_code[digit[count+2]]

  repeat
    repeat display_loop from 0 to 59
        repeat count from 0 to 3
            outa[24+count] := 0
            outa[15..8] := segment_code[digit[count]]
            outa[24+count] :=1
            waitcnt(clkfreq/240 + cnt)
            outa[24+count] := 0
                

 