{{
''***********************************************
''*  Program 8.1
''*  Author: Jon Titus 12-05-2014 Rev. 1
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Shift register control program uses
''*  74HC595 chip. P8 for data, P9 for clock
''*  P10 for register clock. This program shows
''*  how bits get shifted into the IC and displayed
''*  on eight LEDs.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal

VAR byte ser_data
    byte data_port
    byte serial_clock
    byte register_clock                 'Byte storage for PWM duty cycle
                                          
PUB Start                               'Main program starts here
  ser_data := %11101001                 'Data for shift register
  dira[8..10] := %111                   'Three outputs at P8, P9, and P10
  outa[8..10] := %000                   'Set outputs to logic-0
  data_port := 8                        'Define pins for shift-register
  serial_clock := 9                     'input signals
  register_clock := 10

  outa[register_clock] := 0             'Set proper logic levels to start
  outa[register_clock] := 1
  outa[register_clock] := 0
  waitcnt(cnt + clkfreq)                'Short delay
  
  repeat 8                              'Loop to shift 8 bits of data

    if (ser_data => 128)                'Test MSB of serial data going to
                                        'shift register. If this value equals
                                        'or exceeds 128, MSB must = a 1
        outa[data_port] := 1            'Send a 1 to the shift register
    else                                'MSB =0, so send shift reg a 0
        outa[data_port] :=0

    ser_data := ser_data << 1           'Shift the serial data one bit to left
    outa[serial_clock]  := 1            'Clock the shift register to accept new bit
    outa[serial_clock]  := 0
    outa[register_clock] := 1           'Pulse register to transfer data to shift-reg
    outa[register_clock] := 0           'outputs
    waitcnt(cnt + clkfreq)              'Short delay so you can see the pattern shift

  repeat                                'Program ends, keep MCU running this do-                                
    ser_data := ser_data                'nothing loop "forever."
    
    