{{
''***********************************************
''*  Program 8.2
''*  Author: Jon Titus 12-05-2014 Rev. 2
''*  Copyright 2014
''*  Released under Apache 2 license
''*  Shift register control program uses
''*  74HC595 chip. P8 for data, P9 for clock
''*  P10 for register clock. This program shows
''*  how bits get shifted into the IC and displayed
''*  on eight LEDs.
''*  Briefly ground the SRCLR pin on the 74HC595
''*  chip before you run this program. This action
''*  clears the shift register for a clean start.
''***********************************************
}}

CON _clkmode = xtal1 + pll16x           'Set MCU clock operation
    _xinfreq = 5_000_000                'Set for 5 MHz crystal

VAR byte ser_data                       '8-bit serial data
    byte data_port                      'Data-output pin to shift reg
    byte serial_clock                   'Pulse for shift reg clock
    byte register_clock                 'Pulse for register-transfer clock
                                         
PUB Start                               'Main program starts here
  ser_data := %10111101                 'Save 8 serial bits here
  dira[8..10] := %111                   'Select 3 output pins
  outa[8..10] := %000                   'Clear the output pins
  data_port := 8                        'Pin P8
  serial_clock := 9                     'Pin P9
  register_clock := 10                  'Pin P10

  outa[register_clock] := 0             'Generate a short register-
  outa[register_clock] := 1             'transfer pulse to clear
  outa[register_clock] := 0             'shift-register outputs
  waitcnt(cnt + clkfreq)                'Delay so you can see cleared bits
  
  repeat 8                              'Repeat loop 8 times for a byte
    if (ser_data => 128)                'test MSB for 1 or 0
        outa[data_port] := 1            'MSB = 1, output 1 on data_port
    else
        outa[data_port] :=0             'MSB = 0, output 0 on data_port
    ser_data := ser_data << 1           'shift serial data 1 bit to left
    outa[serial_clock]  := 1            'Pulse shift register to input
    outa[serial_clock]  := 0            'one bit
    waitcnt(cnt + clkfreq)              'Delay so you wait to see parallel
  outa[register_clock] := 1             'transfer of bits. Pulse RCLK input
  outa[register_clock] := 0             'on 74HC595 IC
  repeat
    ser_data := ser_data                'Do-nothing loop. MCU "waits" here.
    
 '-----end-----   